local function RainbowJellyfishPostInit(self)
	self:AddComponent("fuel")
	self.components.fuel.fuelvalue = TUNING.MED_LARGE_FUEL
	self.components.fuel.fueltype = "CAVE"
end
AddPrefabPostInit("rainbowjellyfish", RainbowJellyfishPostInit)

local function OctopusKingPostInit(self)
	local INTENSITY = .65

	local origin_OnGetItemFromPlayer = self.components.trader.onaccept
	local function OnGetItemFromPlayer(inst, giver, item)
		origin_OnGetItemFromPlayer(inst, giver, item)

		if item and item.prefab == "rainbowjellyfish" then
			inst:DoTaskInTime(30*GLOBAL.FRAMES, function() 
				local quantity = math.random(2)
				for k = 1, quantity do
					local nug = GLOBAL.SpawnPrefab("bioluminescence")
					local pt = GLOBAL.Vector3(inst.Transform:GetWorldPosition()) + GLOBAL.Vector3(0,4.5,0)

					nug.Transform:SetPosition(pt:Get())
					nug:Show()
					nug:DoTaskInTime(30*GLOBAL.FRAMES, function() 
						nug.Light:Enable(true)
						nug:Show()
						nug:RemoveTag("NOCLICK")
						local secs = secs or 1+math.random()
						nug.components.lighttweener:StartTween(nil, INTENSITY, nil, nil, nil, secs)

						local x, y, z = nug.Transform:GetLocalPosition()
						local fx = GLOBAL.SpawnPrefab("splash_water_drop")
						fx.Transform:SetPosition(x, y, z)
					end)

					local down = GLOBAL.TheCamera:GetDownVec()
					local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*GLOBAL.DEGREES
					--local angle = (-TUNING.CAM_ROT-90 + math.random()*60-30)/180*PI
					local sp = math.random()*4+2
					nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))
					nug.components.inventoryitem:OnStartFalling()
				end
			end)
		end
	end

	self.components.trader.onaccept = OnGetItemFromPlayer
end
AddPrefabPostInit("octopusking", OctopusKingPostInit)

--[[
local function BioluminescencePostInit(self)
	local updatelight = self.components.floatable.onwaterfn
	self.components.floatable:SetOnHitWaterFn(function(inst)
		updatelight(inst)
		local x, y, z = inst.Transform:GetLocalPosition()
		local fx = GLOBAL.SpawnPrefab("splash_water_drop")
		fx.Transform:SetPosition(x, y, z)
	end)
end
AddPrefabPostInit("bioluminescence", BioluminescencePostInit)
]]
